

clf reset


clf reset

date = '20130116';
%FILTER = 'OH';
aa = 47;
bb = aa + 1;

%data_dir = strcat('C:\Users\Karoline Nr\Documents\prosjekt\imager\',date,'\',FILTER,'\');
data_dir = strcat('C:\Users\Karoline Nr\Documents\prosjekt\imager\',date,'\');
qqqfiles = dir(strcat(data_dir,'*.fit'));

txt = char(qqqfiles(aa).name);
txt = regexprep(txt, '_', ' ');


A = fitsread(strcat(data_dir,qqqfiles(aa).name));
B = fitsread(strcat(data_dir,qqqfiles(bb).name));

A = int16(A);
B = int16(B);

A = medfilt2(A);
A = wiener2(A);

B = medfilt2(B);
B = wiener2(B);

A = A - min(min(A));
B = B - min(min(B));

x = imsubtract(A,B);

x = medfilt2(x);
x = wiener2(x);
x = x - min(min(x));

% defining sizeProjection for later

sizeProjection = 100000; 


x = x(1:1252,206:1457); %Cropping to give a square
[iSize jSize] = size(x);

y = zeros(iSize,jSize); 

if mod(length(x),2) ~= 0
   disp('Original image pixel count is not equal to an even number')
end

if mod(length(y),2) ~= 0
   disp('Mapped image pixel count is not equal to an even number')
end


 a = 6378.135*10^3;
 b = 6356.75*10^3;
 geolat = 63.406809*pi/180;
 R = sqrt( ((a^2*cos(geolat))^2 + (b^2*sin(geolat))^2) / ((a*cos(geolat))^2 +(b*sin(geolat))^2 ));

 
 
 az = 0.0;
 el = 0.0;
 r = 0.0;
 psi = 0.0;
 a = 0.0;
 c = 0.0;
 alph = 0.0;
 rFish = 0.0;

 h = 87*10^3; %Height of satellite
 centerI = 665.4474; %Location of zenith in original image
 centerJ = 835.6473-206; % 206 To compensate that the image has been cropped.
 ppd = 14.0595;%Pixels per degree
 scale = sizeProjection/(length(x)); %
 
 
 decimalK = 0.0;
 decimalO = 0.0;
 
 
 
 %Making geographically mapped image with same resolution as fish eye image
 for i=1:iSize,
    for j=1:jSize,
        r=sqrt((i-iSize/2)^2+(j-jSize/2)^2);
        r=r*scale; %To give images that covers an area sizeProjection X sizeProjection


        az=atan((iSize/2-i)/(j-jSize/2));


        if (j-jSize/2) < 0
            az=az+pi;
        elseif(j-jSize/2) == 0 && (iSize/2-i) < 0
            az=3/2*pi;
        elseif (j-jSize/2) > 0 && (iSize/2-i) < 0
            az=az+2*pi;
        end

 %Now radius and azimuth in geographical coordinates ...has been
 %obtained. Finding corresponding radius in fisheye ...image via
 %elevation.

        psi=r/(R+h);
        a=2*(R+h)*sin(psi/2);
        alph=(pi-psi)/2;
        c=sqrt(h^2+a^2-2*h*a*cos(alph));
        el=acos(a*sin(alph)/c);

        rFish=ppd*(90-el*180/pi);

 %Finding float indices in fish eye image ...corresponding to indices
 %of pixel in geographical image.
        o=-rFish*sin(az)+centerI;
        k=rFish*cos(az)+centerJ;

 %Handling NAN issues
        if i == iSize/2 && j == jSize/2
            o=centerI;
            k=centerJ;
        end

        y(i,j) = x(round(o),round(k)); %To test without interpolation.
        % Introduces rounding errors.

    end
 end
 

 
figure()
hold on
imagesc(y, [450, 650]);colormap(gray); axis image; axis off;
hold;text(3,(35),txt,'FontName', 'TimesNewRoman','FontSize',10,'FontWeight','bold', 'color', 'y'),hold; 


x1=[856 901 955 1005 1065 1121 1173 1231];
y1=[1231 1200 1168 1141 1115 1094 1067 1040];


x2=[370 459 556 641 744 825 989 1117];
y2=[1240 1168 1085 1018 969 935 886 841];


x3=[6 116 215 354 493 654 822 983];
y3=[1148 1031 925 800 705 625 573 529];




plot(x1,y1,'r.')
plot(x2,y2,'r.')
plot(x3,y3,'r.')



[x1fit,y1fit,R1fit] = circfit(x1,y1);
[x3fit,y3fit,R3fit] = circfit(x3,y3);
[x2fit,y2fit,R2fit] = circfit(x2,y2);


%figure
plot(x1,y1,'b.')
hold on
rectangle('position',[x1fit-R1fit,y1fit-R1fit,R1fit*2,R1fit*2],...
    'curvature',[1,1],'linestyle','-','edgecolor','r');
% title(sprintf('Best fit: R = %0.1f; Ctr = (%0.1f,%0.1f)',...
%     R1fit,x1fit,y1fit));
plot(x1fit,y1fit,'b.')
xlim([x1fit-R1fit-2,x1fit+R1fit+2])
ylim([y1fit-R1fit-2,y1fit+R1fit+2])
axis auto


plot(x2,y2,'c.')
rectangle('position',[x2fit-R2fit,y2fit-R2fit,R2fit*2,R2fit*2],...
    'curvature',[1,1],'linestyle','-','edgecolor','r');
% title(sprintf('Best fit: R = %0.1f; Ctr = (%0.1f,%0.1f)',...
%     R2fit,x2fit,y2fit));
plot(x2fit,y2fit,'c.')
xlim([x2fit-R2fit-2,x2fit+R2fit+2])
ylim([y2fit-R2fit-2,y2fit+R2fit+2])
axis auto


plot(x3,y3,'k.')
rectangle('position',[x3fit-R3fit,y3fit-R3fit,R3fit*2,R3fit*2],...
    'curvature',[1,1],'linestyle','-','edgecolor','r');
% title(sprintf('Best fit: R = %0.1f; Ctr = (%0.1f,%0.1f)',...
%     R3fit,x3fit,y3fit));
plot(x3fit,y3fit,'k.')
xlim([x3fit-R3fit-2,x3fit+R3fit+2])
ylim([y3fit-R3fit-2,y3fit+R3fit+2])
axis auto

hold off


R1 = R1fit
Ctr1 = [x1fit y1fit]

R2 = R2fit
Ctr2 = [x2fit y2fit]

R3 = R3fit
Ctr3 = [x3fit y3fit]

